#ifndef DELFLUENT_H_
#define DELFLUENT_H_
/**
 * @class eoCPTEO_V1DelFluentMutation
 * @author Jacques Bibai
 * @brief definition d'un operateur de mutation : mutation permettant de supprimer
 * un fluent d'une gare.  
 */
template<class GenotypeT> 
class eoCPTEO_V1DelFluentMutation: public eoMonOp<GenotypeT>{
public:
	/**
		 * Constructeur vide
		 */
  eoCPTEO_V1DelFluentMutation()
  {
    
  }
	string className() const { return "eoCPTEO_V1DelFluentMutation"; }

  /**
   * @fn bool operator()(GenotypeT &)
   * @brief Operateur decrivant la maniere d'effectuer une mutation par suppression de fluent. 
   * Ici on tire aleatoirement une gare. Ensuite on supprime un fluent de maniere aleatoire.  
   * @param individu instance de la classe GenotypeT
   *  @return bool : vrai si l'operation a reussi et faux sinon
   */ 
  bool operator()(GenotypeT & _genotype)
  {
	// cout << "**********************is modified del-------------------- \n";
     bool isModified=false;
     //cout << "\n...............before...............\n" << _genotype;
     std::vector<Gene> tmp;
	 tmp.resize(_genotype.getGenome().size());
  
	        unsigned whichStation,whichFluent,pos=0;
	        whichStation =rng.random( _genotype.getBreakStation());
		   	
		   	//else //whichStation=0; 
		   	//whichStation =rng.random(tmp.size());
		   	if(whichStation >= tmp.size())whichStation=tmp.size()-1;
		   	if(_genotype.get(whichStation).size()>1){
			   		for(size_t i=0;i<tmp.size();i++){
				   		tmp[i].getGene().resize(_genotype.get(i).size());
				   		 for(size_t j=0;j<tmp[i].size();j++){
				   		 	tmp[i].set(j,_genotype.get(i).get(j));
				   		 }
			   		}
	        		
	        		if(tmp[whichStation].size()>1)
		        	{
			   			whichFluent=rng.random(tmp[whichStation].size());
			   			_genotype.getGenome().clear();
			   			_genotype.getGenome().resize(tmp.size());
			   			Gene newGene;
			   			newGene.getGene().resize(tmp[whichStation].size()-1);
			   			pos=0;
			   			for(size_t i=0;i<newGene.size();i++){
			   				if(i==whichFluent)pos++;
			   				newGene.set(i,tmp[whichStation].get(pos));
			   				 
			   				pos++;
			   				
			   			}
			   			
				   	for(size_t i=0;i<tmp.size();i++){
				   		 _genotype.get(i).getGene().clear();
				   		if(i!=whichStation)_genotype.set(i,tmp[i]);
				   		else _genotype.set(i,newGene);
				   		tmp[i].getGene().clear();
				   	}
				   	newGene.getGene().clear();
				   	tmp.clear();
		        } else return false;
		   isModified=true;	
    }
    
   return  isModified;


}
};
#endif /*DELFLUENT_H_*/
